## opengv 1.0%2B1git91f4b1

=== debian/control ===
Source: opengv
Section: libdevel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), cmake,
               debhelper-compat (= 13),
               dh-python,
               pybind11-dev,
               libeigen3-dev,
               doxygen,
# for epstopdf
               texlive-font-utils,
               texlive-latex-base,
               texlive-latex-extra,
               ghostscript,
               python3-all-dev:any,
               libpython3-all-dev
Standards-Version: 4.6.1
Homepage: https://laurentkneip.github.io/opengv
Vcs-Git: https://salsa.debian.org/science-team/opengv.git
Vcs-Browser: https://salsa.debian.org/science-team/opengv

Package: libopengv1t64
Provides: ${t64:Provides}
Replaces: libopengv1
Breaks: libopengv1 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Computer vision methods for solving geometric vision problems.
 Contains absolute-pose, relative-pose, triangulation, and point-cloud alignment
 methods for the calibrated case. All problems can be solved with central or
 non-central cameras, and embedded into a random sample consensus or nonlinear
 optimization context. Matlab and Python interfaces are implemented as well
 .
 This package contains the run-time libraries

Package: libopengv-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libopengv1t64 (= ${binary:Version})
Suggests: libopengv-doc
Description: Computer vision methods for solving geometric vision problems.
 Contains absolute-pose, relative-pose, triangulation, and point-cloud alignment
 methods for the calibrated case. All problems can be solved with central or
 non-central cameras, and embedded into a random sample consensus or nonlinear
 optimization context. Matlab and Python interfaces are implemented as well
 .
 This package contains the build-time libraries

Package: python3-opengv
Section: python
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libopengv1t64 (= ${binary:Version}),
         ${python3:Depends}
Provides: ${python3:Provides}
Description: Computer vision methods for solving geometric vision problems.
 Contains absolute-pose, relative-pose, triangulation, and point-cloud alignment
 methods for the calibrated case. All problems can be solved with central or
 non-central cameras, and embedded into a random sample consensus or nonlinear
 optimization context. Matlab and Python interfaces are implemented as well
 .
 This package contains the Python interface

Package: libopengv-doc
Architecture: all
Depends: ${misc:Depends}
Description: Computer vision methods for solving geometric vision problems.
 Contains absolute-pose, relative-pose, triangulation, and point-cloud alignment
 methods for the calibrated case. All problems can be solved with central or
 non-central cameras, and embedded into a random sample consensus or nonlinear
 optimization context. Matlab and Python interfaces are implemented as well
 .
 This package contains the documentation
