## opengv 1.0+1git91f4b1

=== debian/changelog ===
opengv (1.0+1git91f4b1-9ubuntu1) resolute; urgency=medium

  * d/rules: Enforce EIGEN_MAX_ALIGN_BYTES=16 for amd64v3 (LP: #2138798).

 -- Lena Voytek <lena.voytek@canonical.com>  Wed, 11 Feb 2026 10:47:24 -0500

opengv (1.0+1git91f4b1-9build1) resolute; urgency=medium

  * Another no-change rebuild with Python 3.14 for amd64v3

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 18 Jan 2026 15:27:22 +0000

opengv (1.0+1git91f4b1-9) unstable; urgency=medium

  * Support cmake 4 (Closes: 1113356)

 -- Dima Kogan <dkogan@debian.org>  Sat, 08 Nov 2025 20:02:30 -0800

opengv (1.0+1git91f4b1-8) unstable; urgency=medium

  * Added Build-Depends: python3-setuptools (Closes: #1080886)

 -- Dima Kogan <dkogan@debian.org>  Thu, 05 Sep 2024 22:16:44 -0700

opengv (1.0+1git91f4b1-7.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063087

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 12:19:02 +0000

opengv (1.0+1git91f4b1-7) unstable; urgency=medium

  [ Stefano Rivera ]
  * Use pybuild to build for multiple Python versions. Thanks Tyler Weaver.
    (Closes: #1024265)

 -- Dima Kogan <dkogan@debian.org>  Sat, 19 Nov 2022 14:34:50 -0800

opengv (1.0+1git91f4b1-6) unstable; urgency=medium

  * Arch:all builds work (Closes: #1020995)
  * Added Build-Depends to fully build the docs

 -- Dima Kogan <dkogan@debian.org>  Wed, 02 Nov 2022 10:34:56 -0700

opengv (1.0+1git91f4b1-5) unstable; urgency=medium

  * Source-only reupload

 -- Dima Kogan <dkogan@debian.org>  Mon, 26 Sep 2022 21:35:45 -0700

opengv (1.0+1git91f4b1-4) unstable; urgency=medium

  * don't run any tests if we're doing a system-independent build
    Hopefully fixes #1020375

 -- Dima Kogan <dkogan@debian.org>  Thu, 22 Sep 2022 17:13:34 -0700

opengv (1.0+1git91f4b1-3) unstable; urgency=medium

  * Team upload.
  * No change source-only upload for testing migration.

  [ Dima Kogan ]
  * fix typo in debian/copyright.

 -- Boyuan Yang <byang@debian.org>  Thu, 25 Aug 2022 13:02:57 -0400

opengv (1.0+1git91f4b1-2) unstable; urgency=medium

  * Initial upload into Debian (Closes: #1014132)

 -- Dima Kogan <dkogan@debian.org>  Sat, 23 Jul 2022 12:32:08 -0700
