=== debian/control ===
--- 
+++ 
@@ -7,6 +7,9 @@
 Build-Depends: dpkg-dev (>= 1.22.5), cmake,
                debhelper-compat (= 13),
                dh-python,
+# for "make install" to work. See
+#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1080886
+               python3-setuptools,
                pybind11-dev,
                libeigen3-dev,
                doxygen,
