=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export PYBUILD_CONFIGURE_ARGS=-DBUILD_TESTS=ON -DBUILD_PYTHON=ON -DBUILD_SHARED_LIBS=ON
export PYBUILD_SYSTEM=cmake

export DEB_CXXFLAGS_MAINT_APPEND = -DEIGEN_MAX_ALIGN_BYTES=16

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_build-arch:
	dh_auto_build -a

override_dh_auto_build-indep:
	doxygen

# no system-independent tests
override_dh_auto_test-indep:
	true

override_dh_auto_install-arch:
	dh_auto_install

override_dh_auto_install-indep:
	true

override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/html doc/latex
